package ru.voskhod.smev.client.api.services.admin;

import ru.voskhod.smev.client.api.types.exception.SMEVProcessingException;
import ru.voskhod.smev.client.api.types.exception.SMEVRuntimeException;

/**
 * Административный сервис
 */
public interface AdminService {

    /**
     *  Метод переключения с основного ГРУ, на резерный
     * @return true - в случае успешного переключения, false - иначе
     * @throws SMEVRuntimeException
     * @throws SMEVProcessingException
     */
    boolean switchNode() throws SMEVRuntimeException, SMEVProcessingException;

    /**
     * Возвращает мнемонику текущего ГРУ
     * @return мнемоника текущего ГРУ
     * @throws SMEVRuntimeException
     * @throws SMEVProcessingException
     */
    String getCurrentNode() throws SMEVRuntimeException, SMEVProcessingException;
}
