package ru.voskhod.smev.client.api.services.admin.configuration;

import ru.voskhod.smev.client.api.configuration.SMEVConfiguration;
import ru.voskhod.smev.client.api.services.identification.configuration.IdentityServiceConfiguration;
import ru.voskhod.smev.client.api.services.signature.configuration.SignerConfiguration;

/**
 * Конфигурация административного сервиса
 */
public interface AdminServiceConfiguration extends SMEVConfiguration {

    /**
     * @return строковое представление URL для WSDL сервиса
     */
    String getUrl();

    /**
     * @return timeout подключения к сервису
     */
    int getTimeout();

    /**
     * Возвращает конфигурацию сервиса идентификации
     *
     * @return конфигурацию сервиса идентификации
     */
    IdentityServiceConfiguration getIdentityConfig();

    /**
     * Возвращает конфигурацию сервиса электронной подписи
     *
     * @return конфигурацию сервиса электронной подписи
     */
    SignerConfiguration getSignerConfig();
}
