package ru.voskhod.smev.client.api.services.template;

import ru.voskhod.smev.client.api.types.exception.SMEVException;
import ru.voskhod.smev.client.api.types.message.attachment.SMEVAttachment;

import java.io.File;
import java.util.List;

/**
 * Базовый интерфейс для работы со списком вложений
 */
public interface AttachmentTemplate {

    /**
     * Формирует список вложений на основе указанного списка файлов
     *
     * @param files список вкладываемых файлов
     * @return список вложений
     * @throws SMEVException в случае ошибки
     */
    List<? extends SMEVAttachment> createAttachments(List<File> files) throws SMEVException;
}
