package ru.voskhod.smev.client.api.services.validation;

import ru.voskhod.smev.client.api.types.exception.SMEVProcessingException;
import ru.voskhod.smev.client.api.types.exception.SMEVRuntimeException;


/**
 * Сервис валидации
 *
 * @param <T> тип валидируемого объека
 */
public interface Validator<T> {

    /**
     * Проверяет указанный объект на валидность
     *
     * @param element объект для проверки
     * @throws SMEVRuntimeException    в случае ошибки при конвертации объектов либо других ошибок
     * @throws SMEVProcessingException если указанный объек невалиден
     */
    public abstract void validate(T element) throws SMEVRuntimeException, SMEVProcessingException;
}
