package ru.voskhod.smev.client.api.factory.loaders;

import ru.voskhod.smev.client.api.services.signature.Signer;
import ru.voskhod.smev.client.api.services.signature.configuration.SignerConfiguration;
import ru.voskhod.smev.client.api.types.exception.SMEVRuntimeException;


/**
 * The interface Signer loader.
 */
public interface SignerLoader {

    /**
     * Gets signer.
     *
     * @param <T>    the type parameter
     * @param config the config
     * @return the signer
     * @throws SMEVRuntimeException the smev runtime exception
     */
    <T extends SignerConfiguration> Signer getSigner(T config) throws SMEVRuntimeException;

}
