package ru.voskhod.smev.client.api.factory.loaders;

import ru.voskhod.smev.client.api.services.transport.GeoMessageTransport;
import ru.voskhod.smev.client.api.services.transport.MessageTransport;
import ru.voskhod.smev.client.api.services.transport.configuration.GeoMessageTransportConfiguration;
import ru.voskhod.smev.client.api.services.transport.configuration.MessageTransportConfiguration;


/**
 * The interface Transport loader.
 */
public interface TransportLoader {
    /**
     * Gets transport instance.
     *
     * @param <T>    the type parameter
     * @param config the config
     * @return the transport instance
     */
    <T extends MessageTransportConfiguration> MessageTransport getTransportInstance(T config);

    <T extends GeoMessageTransportConfiguration> GeoMessageTransport getTransportInstance(T config);
}
