package ru.voskhod.smev.client.api.factory.loaders;


import ru.voskhod.smev.client.api.services.messaging.ExceptionMapper;
import ru.voskhod.smev.client.api.services.messaging.MessageMapper;
import ru.voskhod.smev.client.api.services.messaging.configuration.MessageGenerationConfiguration;

/**
 * The interface Types mapper loader.
 */
public interface TypesMapperLoader {
    /**
     * Gets message mapper.
     *
     * @param <T>    the type parameter
     * @param config the config
     * @return the message mapper
     */
    <T extends MessageGenerationConfiguration> MessageMapper getMessageMapper(T config);

    /**
     * Gets exception mapper.
     *
     * @param <T>    the type parameter
     * @param config the config
     * @return the exception mapper
     */
    <T extends MessageGenerationConfiguration> ExceptionMapper getExceptionMapper(T config);
}
