package ru.voskhod.smev.client.api.admin.configuration;

import ru.voskhod.smev.client.api.services.admin.configuration.AdminServiceConfiguration;
import ru.voskhod.smev.client.api.services.identification.configuration.IdentityServiceConfiguration;
import ru.voskhod.smev.client.api.services.signature.configuration.SignerConfiguration;

import javax.xml.namespace.QName;

public final class AdminConfigurationImpl implements AdminServiceConfiguration {

    private final String url;
    private final int timeout;
    private final SignerConfiguration signerConfiguration;
    private final IdentityServiceConfiguration identityServiceConfiguration;

    /**
     * Url до WSDL - http://localhost:7070/ws?wsdl
     *  @param url
     * @param timeout
     * @param signerConfiguration
     * @param identityServiceConfiguration
     */
    public AdminConfigurationImpl(String url,
                                  int timeout,
                                  SignerConfiguration signerConfiguration,
                                  IdentityServiceConfiguration identityServiceConfiguration) {
        this.url = url;
        this.timeout = timeout;
        this.signerConfiguration = signerConfiguration;
        this.identityServiceConfiguration = identityServiceConfiguration;
//        this.serviceQName = new QName("urn://admserv-smev-gov-ru/admserv/1.0", "AdministrativeService");
    }

    @Override
    public String getUrl() {
        return url;
    }

    @Override
    public int getTimeout() {
        return timeout;
    }

    @Override
    public IdentityServiceConfiguration getIdentityConfig() {
        return identityServiceConfiguration;
    }

    @Override
    public SignerConfiguration getSignerConfig() {
        return signerConfiguration;
    }
}
