package ru.voskhod.smev.client.api.message.loader;


import ru.voskhod.smev.client.api.factory.loaders.TypesMapperLoader;
import ru.voskhod.smev.client.api.message.impl.ExceptionMapperImpl;
import ru.voskhod.smev.client.api.message.impl.MessageMapperImpl;
import ru.voskhod.smev.client.api.services.messaging.ExceptionMapper;
import ru.voskhod.smev.client.api.services.messaging.MessageMapper;
import ru.voskhod.smev.client.api.services.messaging.configuration.MessageGenerationConfiguration;

/**
 * The type Mapper loader.
 */
public class MapperLoader implements TypesMapperLoader {
    @Override
    public <T extends MessageGenerationConfiguration> MessageMapper getMessageMapper(T config) {
        return new MessageMapperImpl();
    }

    @Override
    public <T extends MessageGenerationConfiguration> ExceptionMapper getExceptionMapper(T config) {
        return new ExceptionMapperImpl();
    }
}
