package ru.voskhod.smev.client.api.poll.impl;

import ru.voskhod.smev.client.api.services.poll.SyncCallback;

import javax.xml.namespace.QName;
import java.util.Objects;

/**
 * The type Poll key.
 */
final class PollKey<T> {

    /**
     * The Type.
     */
    final QName type;
    /**
     * The Node id.
     */
    final String nodeId;

    /**
     * Callback
     */
    final SyncCallback<T> callback;

    /**
     * Instantiates a new Poll key.
     *  @param type   the type
     * @param nodeId the node id
     * @param callback callback
     */
    PollKey(QName type, String nodeId, SyncCallback<T> callback) {
        this.type = type;
        this.nodeId = nodeId;
        this.callback = callback;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || this.getClass() != obj.getClass())
            return false;
        PollKey that = (PollKey) obj;
        return Objects.equals(this.type, that.type)
                && Objects.equals(this.nodeId, that.nodeId);
    }

    @Override
    public int hashCode() {
        int hash = type.hashCode();
        return 31 * hash + (nodeId != null ? nodeId.hashCode() : 0);
    }

    @Override
    public String toString() {
        if (nodeId == null) {
            return type.toString();
        } else {
            return type + " (" + nodeId + ")";
        }
    }
}
