package ru.voskhod.smev.message_exchange_service_client.push;

import com.sun.xml.ws.transport.http.servlet.WSServlet;
import com.sun.xml.ws.transport.http.servlet.WSServletContextListener;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.servlet.ServletContextHandler;

import java.util.HashMap;
import java.util.Map;

public final class JettyServer {

    public static void setupServer(Server server, String path) throws Exception {
        ServletContextHandler handler = new ServletContextHandler();
        Map<String, byte[]> resources = new HashMap<>();
        String xml =
                "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" +
                        "<endpoints xmlns=\"http://java.sun.com/xml/ns/jax-ws/ri/runtime\" version=\"2.0\">\n" +
                        "    <endpoint name=\"SMEVPushService\" implementation=\"ru.voskhod.smev.message_exchange_service_client.push.PushService\" url-pattern=\"" + path + "\" enable-mtom=\"true\"/>\n" +
                        "</endpoints>";
        resources.put("/WEB-INF/sun-jaxws.xml", xml.getBytes("UTF-8"));
        handler.setBaseResource(new DynamicResource(resources));
        handler.addEventListener(new WSServletContextListener());
        handler.addServlet(WSServlet.class, path);

        server.setHandler(handler);
    }

    public static Server runServer(int port, String path) throws Exception {
        Server server = new Server(port);
        setupServer(server, path);
        // todo: set parameters
        server.start();
        return server;
    }

    public static void main(String[] args) throws Exception {
        runServer(7501, "/ws");
    }
}
