package ru.voskhod.smev.message_exchange_service_client.push;

import ru.voskhod.smev.server.autogenerated.push.PushNotificationException_Exception;
import ru.voskhod.smev.server.autogenerated.push.PushNotificationRequest;

import java.util.concurrent.ConcurrentLinkedQueue;

public class PushListeners {

    private static final PushListeners instance = new PushListeners();
    private final ConcurrentLinkedQueue<PushListener> listeners = new ConcurrentLinkedQueue<>();

    public static PushListeners getInstance() {
        return instance;
    }

    public void addListener(PushListener listener) {
        listeners.add(listener);
    }

    public void removeListener(PushListener listener) {
        listeners.remove(listener);
    }

    public String notifyListeners(PushNotificationRequest notification) throws PushNotificationException_Exception {
        StringBuilder buf = new StringBuilder();
        for (PushListener listener : listeners) {
            String response = listener.pushNotification(notification);
            if (buf.length() > 0) {
                buf.append('\n');
            }
            buf.append(response);
        }
        return buf.toString();
    }
}
