package ru.voskhod.smev.client.api.signature.configuration;

import ru.voskhod.smev.client.api.services.signature.configuration.SignerConfiguration;

import java.io.File;


/**
 * The type Signature configuration.
 */
public class SignatureConfigurationImpl implements SignerConfiguration {
    String providerName;
    String certificateAlias;
    String privateKeyAlias;
    String privateKeyPassword;
    File SMEVFileCertificateStore;

    public SignatureConfigurationImpl(String providerName, String certificateAlias, String privateKeyAlias, String privateKeyPassword, File SMEVFileCertificateStore) {
        this.providerName = providerName;
        this.certificateAlias = certificateAlias;
        this.privateKeyAlias = privateKeyAlias;
        this.privateKeyPassword = privateKeyPassword;
        this.SMEVFileCertificateStore = SMEVFileCertificateStore;
    }

    @Override
    public String getProviderName() {
        return providerName;
    }

    @Override
    public String getCertificateAlias() {
        return certificateAlias;
    }

    @Override
    public String getPrivateKeyAlias() {
        return privateKeyAlias;
    }

    @Override
    public String getPrivateKeyPassword() {
        return privateKeyPassword;
    }

    @Override
    public File getSMEVFileCertificateStore() {
        return SMEVFileCertificateStore;
    }
}
