package ru.voskhod.smev.client.api.template.configuration;

import ru.voskhod.smev.client.api.services.identification.configuration.IdentityServiceConfiguration;
import ru.voskhod.smev.client.api.services.messaging.configuration.MessageGenerationConfiguration;
import ru.voskhod.smev.client.api.services.signature.configuration.SignerConfiguration;
import ru.voskhod.smev.client.api.services.transport.configuration.LargeAttachmentTransportConfiguration;
import ru.voskhod.smev.client.api.services.transport.configuration.MessageTransportConfiguration;
import ru.voskhod.smev.client.api.services.validation.configuration.ValidatorConfiguration;


/**
 * The type Ws configuration.
 */
public class WSConfigurationImpl implements ru.voskhod.smev.client.api.services.template.configuration.WSTemplateConfiguration {

    private IdentityServiceConfiguration identityConfig;
    private SignerConfiguration signerConfig;
    private ValidatorConfiguration validatorConfig;
    private final MessageTransportConfiguration transportConfiguration;

    public WSConfigurationImpl(IdentityServiceConfiguration identityConfig,
                               SignerConfiguration signerConfig,
                               ValidatorConfiguration validatorConfig,
                               MessageTransportConfiguration transportConfiguration,
                               MessageGenerationConfiguration messageGenerationConfig,
                               LargeAttachmentTransportConfiguration largeAttachmentTransportConfig,
                               String localStorage, boolean validateSmevSignature,
                               boolean logInput,
                               boolean logOutput,
                               boolean validateOutput,
                               boolean validateInput) {
        this.identityConfig = identityConfig;
        this.signerConfig = signerConfig;
        this.validatorConfig = validatorConfig;
        this.transportConfiguration = transportConfiguration;
        this.messageGenerationConfig = messageGenerationConfig;
        this.largeAttachmentTransportConfig = largeAttachmentTransportConfig;
        this.localStorage = localStorage;
        this.validateSmevSignature = validateSmevSignature;
        this.logInput = logInput;
        this.logOutput = logOutput;
        this.validateOutput = validateOutput;
        this.validateInput = validateInput;
    }

    private MessageGenerationConfiguration messageGenerationConfig;
    private LargeAttachmentTransportConfiguration largeAttachmentTransportConfig;
    private String localStorage;
    private boolean validateSmevSignature;
    private boolean logInput;
    private boolean logOutput;
    private boolean validateOutput;
    private boolean validateInput;

    @Override
    public IdentityServiceConfiguration getIdentityConfig() {
        return identityConfig;
    }

    @Override
    public SignerConfiguration getSignerConfig() {
        return signerConfig;
    }

    @Override
    public ValidatorConfiguration getValidatorConfig() {
        return validatorConfig;
    }

    @Override
    public MessageTransportConfiguration getMessageTransportConfiguration() {
        return transportConfiguration;
    }

    @Override
    public MessageGenerationConfiguration getMessageGenerationConfig() {
        return messageGenerationConfig;
    }

    @Override
    public LargeAttachmentTransportConfiguration getLargeAttachmentTransportConfig() {
        return largeAttachmentTransportConfig;
    }

    @Override
    public boolean getLoggingOutput() {
        return logOutput;
    }

    @Override
    public boolean getValidateOutput() {
        return validateOutput;
    }

    @Override
    public boolean getValidateInput() {
        return validateInput;
    }

    @Override
    public boolean getLoggingInput() {
        return logInput;
    }

    @Override
    public boolean getValidateSMEVSignature() {
        return validateSmevSignature;
    }

    @Override
    public String getLocalStorage() {
        return localStorage;
    }
}
