package ru.voskhod.smev.client.api.transport.loader;

import ru.voskhod.smev.client.api.factory.loaders.TransportLoader;
import ru.voskhod.smev.client.api.services.transport.GeoMessageTransport;
import ru.voskhod.smev.client.api.services.transport.MessageTransport;
import ru.voskhod.smev.client.api.services.transport.configuration.GeoMessageTransportConfiguration;
import ru.voskhod.smev.client.api.services.transport.configuration.MessageTransportConfiguration;
import ru.voskhod.smev.client.api.transport.impl.GeoMessageTransportImpl;
import ru.voskhod.smev.client.api.transport.impl.MessageTransportImpl;

/**
 * The type Loader.
 */
public class Loader implements TransportLoader {


    @Override
    public <T extends MessageTransportConfiguration> MessageTransport getTransportInstance(T config) {
        try {
            return new MessageTransportImpl(config);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public <T extends GeoMessageTransportConfiguration> GeoMessageTransport getTransportInstance(T config) {
        try {
            return new GeoMessageTransportImpl(config);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
