
package ru.voskhod.smev.server.autogenerated;

import ru.voskhod.smev.server.autogenerated.types.*;
import ru.voskhod.smev.server.autogenerated.types.basic.Void;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;


/**
 * 
 *             Точка доступа, позволяющая принимать запросы любых типов,
 *             а также заявки на предоставление госуслуг.
 *             Кроме того, через этот сервис производится отмена запросов.
 *             Поскольку СМЭВ поколения 2 работает в режиме принудительной передачи ответов,
 *             функциональность "узнать статус запроса и получить ответ, если он готов" отсутствует.
 *         
 * 
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.2.6b21 
 * Generated source version: 2.0
 * 
 */
@WebService(name = "SMEVMessageExchangePortType", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/1.2")
@SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
public interface SMEVMessageExchangePortType {


    /**
     * 
     *                 Послать запрос.
     *                 Факт прихода запроса говорит о том, что СМЭВ удостоверился в том, что отправитель
     *                 имеет право на получение данных по этому типу запросов.
     *                 Дополнительный контроль доступа в ИС-поставщике данных запрещён.
     *                 Тип запроса идентифицируется полным именем (qualified name) элемента //SendRequestRequest/PrimaryContent/element().
     *             
     * 
     * @param parameters
     * @return
     *     returns ru.voskhod.smev.server.autogenerated.types.v1_2.SendRequestResponse
     * @throws SenderIsNotRegisteredException
     * @throws EndOfLifeException
     * @throws AttachmentContentMiscoordinationException
     * @throws AccessDeniedException
     * @throws DestinationOverflowException
     * @throws AttachmentSizeLimitExceededException
     * @throws InvalidMessageIdFormatException
     * @throws TransactionCodeInvalidException
     * @throws StaleMessageIdException
     * @throws SignatureVerificationFaultException
     * @throws MessageIsAlreadySentException
     * @throws SMEVFailureException
     * @throws InvalidContentException
     * @throws BusinessDataTypeIsNotSupportedException
     * @throws QuoteLimitExceededException
     * @throws RecipientIsNotFoundException
     */
    @WebMethod(operationName = "SendRequest", action = "urn:SendRequest")
    @WebResult(name = "SendRequestResponse", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
    public SendRequestResponse sendRequest(
        @WebParam(name = "SendRequestRequest", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
        SendRequestRequest parameters)
        throws AccessDeniedException, AttachmentContentMiscoordinationException, AttachmentSizeLimitExceededException, BusinessDataTypeIsNotSupportedException, DestinationOverflowException, EndOfLifeException, InvalidContentException, InvalidMessageIdFormatException, MessageIsAlreadySentException, QuoteLimitExceededException, RecipientIsNotFoundException, SMEVFailureException, SenderIsNotRegisteredException, SignatureVerificationFaultException, StaleMessageIdException, TransactionCodeInvalidException
    ;

    /**
     * 
     *                 Дай сообщение из моей входящей очереди, если она не пуста.
     *             
     * 
     * @param parameters
     * @return
     *     returns ru.voskhod.smev.server.autogenerated.types.v1_2.SendResponseResponse
     * @throws SenderIsNotRegisteredException
     * @throws AttachmentContentMiscoordinationException
     * @throws DestinationOverflowException
     * @throws IncorrectResponseContentTypeException
     * @throws AttachmentSizeLimitExceededException
     * @throws InvalidMessageIdFormatException
     * @throws StaleMessageIdException
     * @throws MessageIsAlreadySentException
     * @throws SignatureVerificationFaultException
     * @throws SMEVFailureException
     * @throws InvalidContentException
     * @throws BusinessDataTypeIsNotSupportedException
     * @throws QuoteLimitExceededException
     * @throws RecipientIsNotFoundException
     */
    @WebMethod(operationName = "SendResponse", action = "urn:SendResponse")
    @WebResult(name = "SendResponseResponse", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
    public SendResponseResponse sendResponse(
        @WebParam(name = "SendResponseRequest", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
        SendResponseRequest parameters)
        throws AttachmentContentMiscoordinationException, AttachmentSizeLimitExceededException, BusinessDataTypeIsNotSupportedException, DestinationOverflowException, IncorrectResponseContentTypeException, InvalidContentException, InvalidMessageIdFormatException, MessageIsAlreadySentException, QuoteLimitExceededException, RecipientIsNotFoundException, SMEVFailureException, SenderIsNotRegisteredException, SignatureVerificationFaultException, StaleMessageIdException
    ;

    /**
     * Дай сообщение из моей входящей очереди _запросов_, если она не пуста.
     * 
     * @param parameters
     * @return
     *     returns ru.voskhod.smev.server.autogenerated.types.v1_2.GetRequestResponse
     * @throws SenderIsNotRegisteredException
     * @throws UnknownMessageTypeException
     * @throws SignatureVerificationFaultException
     * @throws SMEVFailureException
     * @throws InvalidContentException
     */
    @WebMethod(operationName = "GetRequest", action = "urn:GetRequest")
    @WebResult(name = "GetRequestResponse", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
    public GetRequestResponse getRequest(
        @WebParam(name = "GetRequestRequest", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
        GetRequestRequest parameters)
        throws InvalidContentException, SMEVFailureException, SenderIsNotRegisteredException, SignatureVerificationFaultException, UnknownMessageTypeException
    ;

    /**
     * Дай сообщение из моей входящей очереди _запросов_, если она не пуста.
     * 
     * @param parameters
     * @return
     *     returns ru.voskhod.smev.server.autogenerated.types.v1_2.GetStatusResponse
     * @throws SenderIsNotRegisteredException
     * @throws UnknownMessageTypeException
     * @throws SignatureVerificationFaultException
     * @throws SMEVFailureException
     * @throws InvalidContentException
     */
    @WebMethod(operationName = "GetStatus", action = "urn:GetStatus")
    @WebResult(name = "GetStatusResponse", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
    public GetStatusResponse getStatus(
        @WebParam(name = "GetStatusRequest", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
        GetStatusRequest parameters)
        throws InvalidContentException, SMEVFailureException, SenderIsNotRegisteredException, SignatureVerificationFaultException, UnknownMessageTypeException
    ;

    /**
     * Дай сообщение из моей входящей очереди _ответов_, если она не пуста.
     * 
     * @param parameters
     * @return
     *     returns ru.voskhod.smev.server.autogenerated.types.v1_2.GetResponseResponse
     * @throws SenderIsNotRegisteredException
     * @throws UnknownMessageTypeException
     * @throws SignatureVerificationFaultException
     * @throws SMEVFailureException
     * @throws InvalidContentException
     */
    @WebMethod(operationName = "GetResponse", action = "urn:GetResponse")
    @WebResult(name = "GetResponseResponse", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
    public GetResponseResponse getResponse(
        @WebParam(name = "GetResponseRequest", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
        GetResponseRequest parameters)
        throws InvalidContentException, SMEVFailureException, SenderIsNotRegisteredException, SignatureVerificationFaultException, UnknownMessageTypeException
    ;

    /**
     * 
     *                 Подтверждение получения сообщения из очереди.
     *                 Должен вызваться после получения сообщения методами GetRequest или GetResponse.
     *             
     * 
     * @param parameters
     * @return
     *     returns ru.voskhod.smev.server.autogenerated.types.basic.Void
     * @throws SenderIsNotRegisteredException
     * @throws TargetMessageIsNotFoundException
     * @throws SignatureVerificationFaultException
     * @throws SMEVFailureException
     * @throws InvalidContentException
     */
    @WebMethod(operationName = "Ack", action = "urn:Ack")
    @WebResult(name = "AckResponse", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
    public Void ack(
        @WebParam(name = "AckRequest", targetNamespace = "urn://x-artefacts-smev-gov-ru/services/message-exchange/types/1.2", partName = "parameters")
        AckRequest parameters)
        throws InvalidContentException, SMEVFailureException, SenderIsNotRegisteredException, SignatureVerificationFaultException, TargetMessageIsNotFoundException
    ;

}
