package ru.voskhod.smev.client.toolset.validation;

import org.apache.commons.cli.Option;
import org.apache.commons.cli.Options;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.voskhod.smev.client.api.types.exception.SMEVRuntimeException;
import ru.voskhod.smev.client.toolset.commons.AbstractTool;

/**
 * Утилита для использования {@link ru.voskhod.smev.client.api.services.validation.Validator сервиса валидации}
 */
public class Main extends AbstractTool {

    /**
     * Логгер
     */
    private static final Logger LOG = LoggerFactory.getLogger(Main.class);

    /**
     * Запускает утилиту
     *
     * @param args параметры командной строки
     */
    public static void main(String[] args) {
        //todo: implement
    }

    /**
     * Создает экземпляр утилиты с указанными параметрам
     *
     * @param args параметры командной строки
     */
    private Main(String[] args) throws SMEVRuntimeException {
        super(args);
    }

    /**
     * Добавляет специфические для данной утилиты параметры
     *
     * @param options описание параметров командной строки
     */
    @Override
    protected void populateOptions(Options options) {
        //параметры
        Option inputFile = Option.builder(PARAM_INPUT_FILE).hasArg().argName("имя файла").desc("Путь к входному файлу с содержанием сообщения").build();
        options.addOption(inputFile);
        Option outputFile = Option.builder(PARAM_OUTPUT_FILE).hasArg().argName("имя файла").desc("Путь к выходному файлу").build();
        options.addOption(outputFile);
    }
}
